=begin
== Copyright and License
Copyright 2008,2009 Complex Automata Simulation Technique (COAST) consortium

GNU Lesser General Public License

This file is part of MUSCLE (Multiscale Coupling Library and Environment).

    MUSCLE is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    MUSCLE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with MUSCLE.  If not, see <http://www.gnu.org/licenses/>.

== Author
Jan Hegewald
=end

# configuration file for a MUSCLE CxA
abort "this is a configuration file for to be used with the MUSCLE bootstrap utility" if __FILE__ == $0

# configure cxa properties
cxa = Cxa.LAST

cxa.env["max_timesteps"] = 10000
cxa.env["default_dt"] = 1
cxa.env["nx"] = 100
cxa.env["ny"] = 50
cxa.env["dx"] = 4
cxa.env["wrapAround"] = false 
cxa.env["cxa_path"] = File.dirname(__FILE__)

# declare kernels
cxa.add_kernel('east', 'examples.laplace.KernelEast')
cxa.add_kernel('west', 'examples.laplace.KernelWest')

# configure connection scheme
cs = cxa.cs

cs.attach('east' => 'west') {
	tie('westBoundary', 'remoteEast')
	if cxa.env["wrapAround"]
		tie('eastBoundary', 'remoteWest')
	end
}

cs.attach('west' => 'east') {
	tie('eastBoundary', 'remoteWest')
	if cxa.env["wrapAround"]
		tie('westBoundary', 'remoteEast')
	end
}
